module Coder where

import Instruction

codingError = error . ("coding error: " ++)

coding (i@(address, machineCodes, ins, comment):is) =
    codingAddress address ++ ":\t" ++
    codingMachineCodes machineCodes ++ "\t" ++
    codingMnemonic (ins, comment) ++ "\n" ++
    if is == []
    then
        codingAddress (address + length machineCodes) ++ ":" ++ "\t\t\t" ++codingComment "generated by gmc4cc (terus)" ++ "\n"
    else
        coding is
coding [] = "" 

codingMnemonic (ins, comment) =
    case ins of
      i@(Label _) -> show i ++ "\t" ++ codingComment comment
      i -> "\t" ++ show i ++ codingComment comment

codingAddress = hexString 2

codingMachineCodes = unwords . map hexChar

codingComment "" = ""
codingComment s = "\t\t# " ++ s

codingFxp = ("<?xml version=\"1.0\"?>\n<ArrayOfString xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\n" ++) . 
            (++"</ArrayOfString>\n") .
            (codingFxpInstructions 0x60) 
codingFxpInstructions n ((address, machineCodes, ins, comment):is) =
    concat (map (("  <string>"++).(++"</string>\n").hexChar) machineCodes) ++ codingFxpInstructions (n - length machineCodes) is
codingFxpInstructions n [] | n <= 0 = "" 
codingFxpInstructions n [] = "  <string>F</string>\n" ++ codingFxpInstructions (n - 1) []
